//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  Red

extern string TimeFrame1   = "Current time frame";
extern string TimeFrame2   = "next1";
extern string TimeFrame3   = "next2";
extern int    RsiPeriod    = 3;
extern int    UpDownPeriod = 2;
extern int    ROCPeriod    = 100;
extern int    Price        = PRICE_CLOSE;
//
//
//
//
//

double rsi1[];
double rsi2[];
double rsi3[];
double prices[];
double updown[];
double roc[];

int    timeFrames[4];
bool   returnBars;
bool   calculateValue;
string indicatorFileName;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,rsi1);
   SetIndexBuffer(1,rsi2);
   SetIndexBuffer(2,rsi3);
   SetIndexBuffer(3,prices);
   SetIndexBuffer(4,updown); SetIndexEmptyValue(2,0);
   SetIndexBuffer(5,roc);
      indicatorFileName = WindowExpertName();
      returnBars     = (TimeFrame1=="returnBars");     if (returnBars)     return(0);
      calculateValue = (TimeFrame1=="calculateValue"); if (calculateValue) return(0);
      
      //
      //
      //
      //
      //
      
      timeFrames[0] = stringToTimeFrame(TimeFrame1);
      timeFrames[1] = stringToTimeFrame(TimeFrame2);
      timeFrames[2] = stringToTimeFrame(TimeFrame3);
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
     if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=Bars-counted_bars;
           if (returnBars) { rsi1[0] = limit+1;  return(0); }
           if (!calculateValue)
           {
               if (timeFrames[0] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[0],indicatorFileName,"returnBars",0,0)*timeFrames[0]/Period()));
               if (timeFrames[1] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[1],indicatorFileName,"returnBars",0,0)*timeFrames[1]/Period()));
               if (timeFrames[2] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[2],indicatorFileName,"returnBars",0,0)*timeFrames[2]/Period()));
               for(int i=limit; i>=0; i--)
               {
                  rsi1[i] = iCustom(NULL,timeFrames[0],indicatorFileName,"calculateValue","","",RsiPeriod,UpDownPeriod,ROCPeriod,Price,0,iBarShift(NULL,timeFrames[0],Time[i]));
                  rsi2[i] = iCustom(NULL,timeFrames[1],indicatorFileName,"calculateValue","","",RsiPeriod,UpDownPeriod,ROCPeriod,Price,0,iBarShift(NULL,timeFrames[1],Time[i]));
                  rsi3[i] = iCustom(NULL,timeFrames[2],indicatorFileName,"calculateValue","","",RsiPeriod,UpDownPeriod,ROCPeriod,Price,0,iBarShift(NULL,timeFrames[2],Time[i]));
               }
               return(0);
            }               
               

   //
   //
   //
   //
   //
     
   for(i=limit; i>=0; i--)
   {
      prices[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         if (prices[i] == prices[i+1]) updown[i] = 0;
         if (prices[i] <  prices[i+1]) if (updown[i+1] > 0) updown[i] = -1; else updown[i] = updown[i+1]-1;
         if (prices[i] >  prices[i+1]) if (updown[i+1] < 0) updown[i] =  1; else updown[i] = updown[i+1]+1;
   }
   for(i=limit; i>=0; i--)
   {   
      double trsi = iRSI(NULL,0,RsiPeriod,Price,i);
      double ursi = iRSIOnArray(updown,0,UpDownPeriod,i);
      roc[i]  = 0;
         if (prices[i+1]!=0) roc[i] = (prices[i]/prices[i+1]-1.0)*100.0;

         double ROC_Percent = 0;
          for (int k=1; k<=ROCPeriod; k++)
              if (roc[i] >= roc[i+k]) ROC_Percent++;
                                     ROC_Percent = (ROC_Percent / ROCPeriod) * 100;

         //
         //
         //
         //
         //
         
         rsi1[i] = (trsi + ursi + ROC_Percent) / 3.0;
   }         
   return(0);
}  

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int toInt(double value) { return(value); }
int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   int max = ArraySize(iTfTable)-1, add=0;
   int nxt = (StringFind(tfs,"NEXT1")>-1); if (nxt>0) { tfs = ""+Period(); add=1; }
       nxt = (StringFind(tfs,"NEXT2")>-1); if (nxt>0) { tfs = ""+Period(); add=2; }
       nxt = (StringFind(tfs,"NEXT3")>-1); if (nxt>0) { tfs = ""+Period(); add=3; }

      //
      //
      //
      //
      //
         
      for (int i=max; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[toInt(MathMin(max,i+add))],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}